#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

int sx, sy;

char scratch[400];
char radek[400][400];
char scratch2[400];
int body;
int odstraneno;
int minx, maxx;

#define DBG(a...)

void fill(int x, int y, int color)
{
  if (radek[y][x]!=color)
    return;
  odstraneno++;
  radek[y][x] = 0;
  if (x < minx)
    minx=x;
  if (x > maxx)
    maxx=x;
  fill(x-1,y,color);
  fill(x+1,y,color);
  fill(x,y-1,color);
  fill(x,y+1,color);
}

void dumpit(void)
{
  int x,y;
  for (y=0; y<sy; y++) {
    for (x=0; x<sx; x++) {
      DBG( "%c", radek[y][x]?radek[y][x]:'.' );
    }
    DBG( "\n" );
  }
  DBG( "\n" );
}

void tah(int x, int y)
{ 
  int lastfull = -1;
  minx = 400; maxx = 0;

  odstraneno = 0;
  DBG("-------------------\n" );
  if (radek[y][x] == 0) {
    DBG("nejde 1 (%d,%d)\n", x, y);
    return;
  }
  if (!(  (radek[y][x-1] == radek[y][x]) ||
	  (radek[y][x+1] == radek[y][x]) ||
	  (radek[y+1][x] == radek[y][x]) ||
	  (radek[y-1][x] == radek[y][x]))) {
    DBG("nejde 2\n");
    return;
  } 

  /*  dumpit(); */
  fill(x,y,radek[y][x]);
  /*  dumpit(); */
  for (x=minx; x<maxx+1; x++) {
    int lastfull = -1;
    for (y=0; y<sy; y++) {
      if ((radek[y][x]) && (lastfull != y-1)) {
	radek[lastfull+1][x] = radek[y][x];
	radek[y][x] = 0;
	lastfull++;
      }
      if (radek[y][x])
	lastfull=y;
    }
  }
  /* dumpit(); */
  lastfull = -1;
  for (x=0; x<sx; x++) {
    if ((radek[0][x]) && (lastfull != x-1)) {
      int i;
      for (i=0; i<sy; i++) {
	radek[i][lastfull+1] = radek[i][x];
	if (!(radek[i][x]))
	    break;
	radek[i][x] = 0;
      }
      lastfull++;
    }
    if (radek[0][x])
	lastfull=x;
  }
  /* dumpit(); */
  body += (odstraneno-2)*(odstraneno-2);
}

int main(void)
{
  int pocet, c_ulohy;
  scanf("%d\n", &pocet);
  memset(scratch, 0, sizeof(scratch));
  memset(scratch2, 0, sizeof(scratch2));
  for (c_ulohy =0; c_ulohy < pocet; c_ulohy++) {
    int i,j,k;
    scanf("%d %d\n", &sx, &sy);
    body = 0;
    memset(radek, 0, sizeof(radek));
    for (i=0; i<sy; i++) {
      scanf("%s\n", radek[sy-i-1]);
    }
    scanf("%d\n", &i);
    for (j=0; j<i; j++) {
      int x,y;
      scanf("%d %d\n", &x, &y);
      tah(x-1,y-1);
    }
    if (radek[0][0] == 0)
      body += 1000;
    printf("Game over!\nScore dosazene v teto hre je %d bodu.\nByli bychom radi, kdybyste si zahrali jeste jednou.\nPrejete si hrat znovu?\nPrijemnou zabavu Vam preje firma ACMTENDO.\n", body);
  }
  return 0;
}
